/* spi.h
 *
 * (c) 23.12.2014 Ingo D. Rullhusen
 *
 */

#ifndef SPI_H
#define SPI_H

#include <linux/clk.h>
#include <linux/device.h>

/*** arch/arm/mach-sun7i/include ***/

#include <mach/dma.h>
#include <mach/spi.h>


typedef struct
{
   void __iomem *base_ptr;

   void __iomem *ptr_rxdata;
   void __iomem *ptr_txdata;
   void __iomem *ptr_ctl;   
   void __iomem *ptr_intctl;
   void __iomem *ptr_int_sta;
   void __iomem *ptr_dmactl;
   void __iomem *ptr_wait;
   void __iomem *ptr_cctl;
   void __iomem *ptr_bc;
   void __iomem *ptr_tc;
   void __iomem *ptr_fifo_sta;

   phys_addr_t paddr;
   const char *name;

   char *spi_dma_rx;
   char *spi_dma_tx;

   unsigned char spi_rx_ddrq, spi_tx_ddrq;

   struct clk *ahb_clock, *clock;


   struct snd_dma_buffer *snd_DMA;
   unsigned int buf_pos;
      
   struct snd_pcm_substream *substream;


   int dma_ch_rx, dma_ch_tx;
   dma_hdl_t DMA_rx, DMA_tx;
   dma_addr_t DMA_addr_rx, DMA_addr_tx;

} sunxi_spi;


int spi_data_init( struct device *dev, sunxi_spi *SPI_DATA, int i );
void spi_data_free( struct device *dev, sunxi_spi *SPI_DATA, int i );

int spi_pcm_preallocate_dma_buffer(sunxi_spi *SPI_DATA, struct snd_pcm_substream *substream);
void spi_pcm_free_dma_buffers(sunxi_spi *SPI_DATA, struct snd_pcm_substream *substream);


#endif
